// NetSDKDemoDlg.h : header file
//

#if !defined(AFX_NETSDKDEMODLG_H__874C22A9_455C_4113_9954_FDC1528EE15D__INCLUDED_)
#define AFX_NETSDKDEMODLG_H__874C22A9_455C_4113_9954_FDC1528EE15D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "searchrecord.h"
#include "clientState.h"
#include "exbutton.h"
#include "systemconfig.h"
#include "PlayWnd.h"
#include "ScreenPannel.h"
#include "PTZPannel.h"
#include "ColorPannel.h"
#include "PlayCtrlPannel.h"
#include "NormalBtnPannel.h"
#include "AdvanceBtnPannel.h"
#include "SaveDataPannel.h"
#include "SelectPannel.h"
#include "RuntimeMsgPannel.h"
#include "AudioBroadcastDlg.h"
#include "downloadbytime.h"
/////////////////////////////////////////////////////////////////////////////
// CNetSDKDemoDlg dialog

#define TIMER_KBPS 1999
#define CUR_MAXCHAN 16
#define	CUR_SPLIT	SPLIT16

enum{
	SPLIT1 = 0,
	SPLIT4,
	SPLIT9,
	SPLIT16,	
	SPLIT_TOTAL
};

enum{
	STATUS_STOP,
	STATUS_PAUSE,
	STATUS_PLAY,
	STATUS_STEP,
};

enum{
	VIDEO_BRIGHT = 0,
	VIDEO_CONTRAST,
	VIDEO_HUE,
	VIDEO_SATURATION,
	VIDEO_TOTAL
};

enum{
	PTZ_START,
	PTZ_STOP
};

typedef struct _SplitMonitorParam
{
	DeviceNode *pDevice;
	int iChannel;
}SplitMonitorParam;

typedef struct _SplitNetPlayParam
{
	FileInfoNode *pFileInfo;
	int   iStatus;
	int   iPlayPos;
}SplitNetPlayParam;

typedef struct _SplitPBByTimeParam
{
	DeviceNode *pDevice;
	NET_TIME starttime;
	NET_TIME endtime;
	int nChannel;
	int npos;
	int iStatus;
}SplitPBByTimeParam;

typedef struct _SplitMulitPlayParam
{
	DeviceNode *pDevice;
}SplitMultiPlayParam;

typedef struct _CycleChannelInfo
{
	DWORD dwDeviceID;
	int iChannel;
}CycleChannelInfo;
typedef struct _SplitCycleParam
{
	DeviceNode *pDevice;
	CPtrList *pChannelList;
	int iChannelCount;
	int iCurPosition;
	UINT iInterval;
}SplitCycleParam;	
/*Begin: Add by yehao(10857) For Task.NO.11071 2006-12-26*/
typedef struct _TalkHandleInfo
{
	DeviceNode *pDevice;
	LONG		lHandle;
} TalkHandleInfo, *LPTalkHandleInfo;
/*End: yehao(10857) Task.NO.11071 */

class CNetSDKDemoDlg : public CDialog
{
// Construction
	int m_connectwaittime; 
	int m_curScreen;
	int m_curSoundSplit;

	void *GetCurDeviceInfo();
	void *FindDeviceInfo(LONG lLoginID, char *sDVRIP,LONG nDVRPort);
	int GetHandleSplit(LONG lPlayHandle);
	BOOL CheckCurSplitAndClose();
	BOOL IsCycling(DWORD deviceID, int channelNo);
	int  GetCurSplitStart(int nScreen, int nSplit);
	int  PlayStop(int iScreen, BOOL bDis = FALSE);

	void UpdateVideoCtrl(int nMode); 
	void UpdateDeviceList(); 
	void UpdateDeviceState(void *pDevice, char *pBuf, DWORD dwBufLen);
	
public:
	CNetSDKDemoDlg(CWnd* pParent = NULL);	// standard constructor

	void DeviceDisConnect(LONG lLoginID, char *sDVRIP,LONG nDVRPort);
	void DeviceReConnect(LONG lLoginID, char *sDVRIP,LONG nDVRPort);
	void ReceiveRealData(LONG lRealHandle, DWORD dwDataType, BYTE *pBuffer, DWORD dwBufSize);
	BOOL ReceiveMessage(LONG lLoginID, LONG lCommand, char *pchDVRIP, LONG nDVRPort, 
		char *pBuf, DWORD dwBufLen);
	void AddDisplayInfo(LONG lLoginID, LONG lPlayHandle, HDC hDC);
	void ReceivePlayPos(LONG lPlayHandle, DWORD dwTotalSize, DWORD dwDownLoadSize);
	int  ListenCallBack_Imp(LONG lServerHandle, char* ip, WORD port, int nCmd, void* pParam);

	void DeleteCycleParam(int nScreen);

	friend void CALLBACK DisConnectFunc(LONG lLoginID, char *pchDVRIP, LONG nDVRPort, DWORD dwUser);
	friend void CALLBACK RealDataCallBack(LONG lRealHandle, DWORD dwDataType, BYTE *pBuffer, 
		DWORD dwBufSize, DWORD dwUser);
	friend int CALLBACK PBDataCallBack(LONG lRealHandle, DWORD dwDataType, BYTE *pBuffer, 
		DWORD dwBufSize, DWORD dwUser);
	friend void CALLBACK RealDataCallBackEx(LONG lRealHandle, DWORD dwDataType, BYTE *pBuffer, 
		DWORD dwBufSize, LONG lParam, DWORD dwUser);
	friend BOOL CALLBACK MessCallBack(LONG lCommand, LONG lLoginID, char *pBuf, 
		DWORD dwBufLen, char *pchDVRIP, LONG nDVRPort);
	friend void CALLBACK ChannelAutoDraw(LONG lLoginID, LONG lPlayHandle, HDC hDC, DWORD dwUser);
	friend void CALLBACK PlayCallBack(LONG lPlayHandle, DWORD dwTotalSize, DWORD dwDownLoadSize, DWORD dwUser);
	friend  int CALLBACK ListenCallBack(LONG lServerHandle, char* ip, WORD port, int nCmd, void* pParam, DWORD dwUserData);
	//for stream parser
//	friend unsigned long __stdcall SpCallBack(PARSERHANDLE hHandle, PARSERMSG msg, 
//		unsigned long dwParam1, unsigned long dwParam2,
//		unsigned long dwUserData);

	CClientState  m_ClientStateDlg;
	
//	CSystemConfig m_SysConfig;
	// Dialog Data
	//{{AFX_DATA(CNetSDKDemoDlg)
	enum { IDD = IDD_NETSDKDEMO_DIALOG };
	CExButton	m_ptz_righttop;
	CExButton	m_ptz_rightdown;
	CExButton	m_ptz_lefttop;
	CExButton	m_ptz_leftdown;
	CExButton	m_zoom_wide;
	CExButton	m_zoom_tele;
	CExButton	m_focus_near;
	CExButton	m_focus_far;
	CExButton	m_iris_open;
	CExButton	m_iris_close;
	CExButton	m_ptz_up;
	CExButton	m_ptz_right;
	CExButton	m_ptz_left;
	CExButton	m_ptz_down;
	CComboBox	m_channelsel;
	CTreeCtrl	m_devicelist;
	int		m_play_frame;
	UINT	m_testvalue;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNetSDKDemoDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual LRESULT DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL
	// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CNetSDKDemoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClose();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnDblclkTreeDevicelist(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	void OpenSingleChannel(DeviceNode *pInfo,int nCh, int screenNo, DH_RealPlayType subtype);
	void OpenAllChannel(DeviceNode *pInfo, DH_RealPlayType subtype);
	void PlayRecordFile(FileInfoNode* playfile, int scrNo);
	BOOL ProcessCloseScreen(int scrNo, BOOL bDis = FALSE);
	BOOL ProcessCloseAllChannel(DeviceNode *pInfo);
	void SwitchFullScreen();
//	void ReturnOrignalSplit(void);
	void UpdateScreen(int nSplit);

	void AddDevice();
	void DeleteDevice();
	void OpenChannel();
	void OpenMultiplay();
	void CloseScreen();
	void CloseAllChannel();
	void SearchRecord();
	void CycleMonitor();
	void Playbackbytime();
	void Downloadbytime();
	void Sysconfig();
	void Sysconfig2();

	BOOL OpenSound(BOOL bOpen);
	BOOL OpenTalk(BOOL bOpen);
	void UpdateDevice();
	void Recordstate();	
	void RebootDevice();
	void AlarmIOctrl();	
	void ShutdownDevice();
	void DeviceState();	
	void CaptureScreen();
	void SetIframe();	
	void ShowFluxInfo();
	void Transcom();		
	void DDNS_QueryIP();		
	void Getversion();		
	void OpenAudioBroadcastDlg();	
	void Dhptzctrl();		
	void Extptzctrl();		

	void SaveRealdata(int nCheck);	
	void SavecbdataRaw(int nCheck);	
	void SavecbdataStd(int nCheck);	
	void Savecbdatapcm(int nCheck);	
	void Savecbdatayuv(int nCheck);	
				
	void PtzControl(int type, BOOL stop, int param); 
	void ProcessDeleteDevice(DeviceNode *pDevice,  BOOL bDelList, BOOL bDis = false); 
	
	void NextCycleMonitor(UINT nID);

	void CtrlColor_Bright(int pos);	
	void CtrlColor_Contrast(int pos);
	void CtrlColor_Saturation(int pos);
	void CtrlColor_Hue(int pos);

	BOOL SeekPlayPositon(int nPos);	
	BOOL PlayCtrl_Play();
	BOOL PlayCtrl_Stop();
	BOOL PlayCtrl_Fast();	
	BOOL PlayCtrl_Slow();		
	BOOL PlayCtrl_Step();		
	BOOL PlayCtrl_Frame(int frame);	

	void GetDeviceWorkstate();	
	void DeviceControldisk();	
	void DeviceUserinfo();	
	
	void SeleteNormalPannel();	
	void SeleteAdvancePannel();	
	void SeleteSaveDataPannel();
	void SeletePTZPannel();	
	void SeleteColorPannel();
	void SeletePlayCtrlPannel();
	void SeleteDevListPannel();	
	
	void UpdatePannelPosition();

	void LastError();	

	void SwitchMultiWnd(int nSplit);

	int	 GetCurWinID(void);

	void SetCurWindId(int nCuWinID)
	{
		m_curScreen = nCuWinID;
	}

	int UpdateDeviceListCallback_Imp(const DeviceNode& node);
	int WriteAlarmLogFunc_Imp(const AlarmNode& node);

	void TestProc(); //for test

	//for stream parser
//	void HandleParserMsg(PARSERHANDLE hHandle, PARSERMSG msg, 
//		unsigned long dwParam1, unsigned long dwParam2);

public:
	int GetCurScreen(){return m_curScreen;}
	void UpdateCurScreenInfo();
	void SetSplit(int split);
	int  GetSplit();
	BOOL GetSplitInfo_Main(int nIndex, SplitInfoNode* info);
	BOOL SetSplitInfo_Main(int nIndex, SplitInfoNode* info);
	/*Begin: Add by yehao(10857) 2006-12-20*/
	static void CALLBACK AudioDataCallBack(LONG lTalkHandle, char *pDataBuf, DWORD dwBufSize, BYTE byAudioFlag, DWORD dwUser);
	LONG GetTalkHandle();
	/*End: yehao(10857) */
private:
	/*Begin: Add by yehao(10857) For Task.NO.11071 2006-12-26*/
	BOOL RecordStart();
	BOOL RecordStop();
	/*End: yehao(10857) Task.NO.11071 */
private:
	BOOL		m_bPTZCtrl;	
	
//	BOOL		m_bFullSCRN;
	CRect		m_clientRect;
	CRect		m_screenRect;
	CRect		m_pannelRect;	
	CRect		m_selectRect;	
	CRect		m_btnAreaRect;	
	CRect		m_runtimeMsgRect;	

	CScreenPannel		m_screenPannel;	
//	CPlayWnd			m_playWnd[MAX_CHANNUM];	
//	CWnd				*m_originParent;
	CPTZPannel			m_ptzPannel;
	CColorPannel		m_colorPannel;
	CPlayCtrlPannel		m_playctrlPannel;
	CNormalBtnPannel	m_normalBtnPannel;
	CAdvanceBtnPannel	m_advanceBtnPannel;
	CSaveDataPannel		m_saveDataPannel;
	CSelectPannel		m_selectPannel;	
	CRuntimeMsgPannel	m_runtimeMsgPannel;	
	/*Begin: Add by yehao(10857) 2006-12-22*/
	list<DeviceNode *>	m_broadcastDevList;
	CAudioBroadcastDlg	m_audioBroadcastDlg;
	BOOL				m_bRecord;
	TalkHandleInfo		m_talkhandle;
	unsigned int		m_uRecordCount;
	/*End: yehao(10857) 2006-12-22*/
	CBrush				m_myBrush;

	
#ifdef DH_STREAMPARSER
	//for stream parser
	PARSERHANDLE m_hSp;
	FILE         *m_spFile;
	BOOL		 m_bGetIFrame;
	int			 m_framecount;
#endif

	//download test
	CDownloadByTime m_dbByTime;

	//specified alarm test
	FILE	*m_almLogFile_Comm;
	FILE	*m_almLogFile_Shelter;
	FILE	*m_almLogFile_dFull;
	FILE	*m_almLogFile_dError;
	FILE	*m_almLogFile_SoundDec;
	
	DEV_STATE	m_lastAlarm;

	//listen device test
	LONG	m_lListenDevice;
	LONG	m_lListenChannel;
	typedef struct 
	{
		int state;
		char ip[16];
		WORD port;
		char serial[48];
	}LISTEN_DATA;
	LISTEN_DATA m_mylsdata;
};

 
//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_NETSDKDEMODLG_H__874C22A9_455C_4113_9954_FDC1528EE15D__INCLUDED_)
