unit dhnetsdk;

interface

uses
        SysUtils,WinTypes;

type
(************************************************************************
 ** Network disconnection callback fucntion original shape
 ***********************************************************************)
        fDisConnect = procedure (lLoginID: LongInt; strDVRIP: Pchar; nDVRPort: LongInt;  dwUser: LongWord); stdcall;

(************************************************************************
 ** Alarm message callback fucntion original shape
 ***********************************************************************)
        fMessCallBack = function (lCommand,lLoginID:LongInt; var pBuf;
			dwBufLen:LongWord; strDVRIP:Pchar; nDVRPort:LongInt; dwUser: LongWord ):LongBool;stdcall;

(************************************************************************
 ** Set screen overlay callback
 ***********************************************************************)
        fDrawCallBack = procedure (lLoginID,lPlayHandle:LongInt; hDC: THandle; dwUser:LongInt);stdcall;

(************************************************************************
 ** Device information
 ***********************************************************************)
        NET_DEVICEINFO=Record
	        sSerialNumber: array [0..47] of Byte;	//SN
        	byAlarmInPortNum: byte;				//DVR alarm input amount
	        byAlarmOutPortNum:BYTE;				//DVR alarm output amount
        	byDiskNum:BYTE;						//DVR HDD amount
	        byDVRType:BYTE ;						//DVR type
        	byChanNum:BYTE;						//DVR channel ammount
        end;

(************************************************************************
 ** SDK Initialization
 ***********************************************************************)
function  CLIENT_Init( cbDisConnect: fDisConnect; dwUser:LongWord): LongBool; stdcall; 

(************************************************************************
 ** SDK exit and clear
 ***********************************************************************)
procedure CLIENT_Cleanup() ; stdcall;

(************************************************************************
 ** Set device connection timeout value and trial times 
 ***********************************************************************)
procedure CLIENT_SetConnectTime(nWaitTime: Integer; nTryTimes: Integer);stdcall; 


(************************************************************************
 ** Get SDK version informaiton
 ***********************************************************************)
function CLIENT_GetSDKVersion(): LongWord;stdcall; 


(************************************************************************
 ** Register to the device
 ***********************************************************************)
function CLIENT_Login(strDVRIP: Pchar; wDVRPort: WORD; strUserName: Pchar; strPassword: Pchar; var netDeviceInfo: NET_DEVICEINFO; error:Pinteger):LongInt;stdcall; 


(************************************************************************
 ** Log out the device
 ***********************************************************************)
function CLIENT_Logout(lLoginID: LongInt):LongBool;stdcall; 



(************************************************************************
 ** Set alarm callback fucntion
 ***********************************************************************)
procedure CLIENT_SetDVRMessCallBack(cbMessage:fMessCallBack; dwUser:LongWord);stdcall; 


(************************************************************************
 ** Set screen overlay callback 
 ***********************************************************************)
procedure CLIENT_RigisterDrawFun(cbDraw:fDrawCallBack; dwUser:LongWord);stdcall; 


(************************************************************************
 ** Begin real-time monitor 
 ***********************************************************************)
function CLIENT_RealPlay(lLoginID:LongInt; nChannelID:Integer; hWnd:HWND):LongInt;stdcall; 


(************************************************************************
 ** Stop real-time preview 
 ***********************************************************************)
function CLIENT_StopRealPlay(lRealHandle:LongInt):LongBool;stdcall; 


implementation


function  CLIENT_Init; external 'dhnetsdk.dll';
procedure CLIENT_Cleanup; external 'dhnetsdk.dll';
procedure CLIENT_SetConnectTime; external 'dhnetsdk.dll';
function CLIENT_Login; external 'dhnetsdk.dll';
function CLIENT_Logout; external 'dhnetsdk.dll';
procedure CLIENT_SetDVRMessCallBack; external 'dhnetsdk.dll';
procedure CLIENT_RigisterDrawFun; external 'dhnetsdk.dll';
function CLIENT_RealPlay; external 'dhnetsdk.dll';
function CLIENT_StopRealPlay; external 'dhnetsdk.dll';
function CLIENT_GetSDKVersion;external 'dhnetsdk.dll';

end.

